import serial
import time
import sys

def OpenPort(pt):
    global ser
    s = '\\\\.\\COM%d' % pt
    ser = serial.Serial(port=s,\
                        baudrate=9600,\
                        parity=serial.PARITY_NONE,\
                        stopbits=serial.STOPBITS_ONE,\
                        bytesize=serial.EIGHTBITS,\
                        timeout=20)

def DisableMotors():
    b = bytearray([58, 90, 10])
    ser.write(b)
    return;

def GetAPI():
    b = bytearray([58, 65, 10])
    ser.write(b)
    r = ser.read(1)
    return(r);

def HomeAll():
    b = bytearray([58, 66, 10])
    ser.write(b)
    a = ser.read(1)
    while a[0]==0:
        a = ser.read(1)
    return;
    
def HomeAxis(i):
    b = bytearray([58, 67, i, 10])
    ser.write(b)
    ser.read(1)
    return;

def GetCurrentPosition():
    b = bytearray([58, 68, 10])
    ser.write(b)
    r = ser.read(6)
    return(r);

def SetRelay(i):
    b = bytearray([58, 69, i, 10])
    ser.write(b)
    return;

def StoreCurrentPosition(index):
    b = bytearray([58, 70, index, 10])
    ser.write(b)
    return;
	
def StoreCoords(index, mot_a, mot_b, mot_c):
    b = bytearray([58, 71, index, mot_a&255, mot_a>>8, mot_b&255, mot_b>>8, mot_c&255, mot_c>>8, 10])
    ser.write(b)
    return;

def GotoPosition(i):
    b = bytearray([58, 72, i, 10])
    ser.write(b)
    return;
    
def SetMotor(index, coord):
    b = bytearray([58, 73, index, coord&255, coord>>8, 10])
    ser.write(b)
    return; 
	
def SetMotors(mot_a, mot_b, mot_c):
    b = bytearray([58, 74, mot_a&255, mot_a>>8, mot_b&255, mot_b>>8, mot_c&255, mot_c>>8, 10])
    ser.write(b)
    return; 
    
def IsMoving():
    b = bytearray([58, 75, 10])
    ser.write(b)
    r = ser.read(1)
    return(r[0]);
    
def GetToolXYZ():
    b = bytearray([58, 76, 10])
    ser.write(b)
    r = ser.read(6)
    return(r); 
	
def MoveToXYZ(mot_x, mot_y, mot_z):
    mot_x = int(mot_x)&0xFFFF
    mot_y = int(mot_y)&0xFFFF
    mot_z = int(mot_z)&0xFFFF
    b = bytearray([58, 77, mot_x&255, mot_x>>8, mot_y&255, mot_y>>8, mot_z&255, mot_z>>8, 10])
    ser.write(b)
    return; 

def SetGripper(i):
    b = bytearray([58, 78, i, 10])
    ser.write(b)
    return;

def GetColourSensor():
    b = bytearray([58, 79, 10])
    ser.write(b)
    r = ser.read(3)
    return(r); 

def SetMovementSpeed(speed, increment):
    b = bytearray([58, 80, speed&255, speed>>8, increment&255, increment>>8, 10])
    ser.write(b)
    return; 

def DisableAllMotors():
    b = bytearray([58, 90, 10])
    ser.write(b)
    return; 

def WriteLED (index, state):
    b = bytearray([58, 97, index, state, 10])
    ser.write(b)
    return; 

def RestoreAutoLEDs():
    b = bytearray([58, 98, 10])
    ser.write(b)
    return; 

def GetPLCInput():
    b = bytearray([58, 103, 10])
    ser.write(b)
    ser.read(1)
    return;




